basefile = 'outputOfCleanScript_WaldSim_empval';
basefile_date = '01may2014';

datesToMerge = {'1990Q3','1994Q3','2008Q4'};

loadData = load([basefile '_' datesToMerge{1} '_' basefile_date]);

storeData = loadData;

storeData.shk_numval = [-.32 -.16 .16 .32];

dgpmodels = {'oil_gdp_ni3'};
fitmodels = {'oil_gdp','oil_gdp_ni3'};
nstep = storeData.nstep;
nvars = 2;
nshocks = storeData.nshocks;
nstartpoints = length(datesToMerge);
nsimdataset = size(storeData.simstruct.(dgpmodels{1}).simdata,3);

for idgp = 1:length(dgpmodels)
    
    dgpuse = dgpmodels{idgp};
    
    for ifit = 1:length(fitmodels)
        
        fituse = fitmodels{ifit};
        
        storeData.simstruct.(dgpuse).(fituse).frcst = NaN(nstep,nvars,nshocks,nstartpoints,nsimdataset);
        storeData.simstruct.(dgpuse).(fituse).cumfrcst = NaN(nstep,nvars,nshocks,nstartpoints,nsimdataset); 
        storeData.simstruct.(dgpuse).(fituse).oilimpz = NaN(nstep,nvars,nshocks,nstartpoints,nsimdataset);
        storeData.simstruct.(dgpuse).(fituse).cumoilimpz = NaN(nstep,nvars,nshocks,nstartpoints,nsimdataset);        
        
    end
end

for ifit = 1:length(fitmodels)
    
    fituse = fitmodels{ifit};    
    
    storeData.empstruct.(fituse).oilimpz = NaN(nstep,nvars,nshocks,nstartpoints);
    storeData.empstruct.(fituse).cumoilimpz = NaN(nstep,nvars,nshocks,nstartpoints);
    
end
        
storeData.infosetdates = cell(nstartpoints,1);

for idate = 1:length(datesToMerge)
    
    loadData = load([basefile '_' datesToMerge{idate} '_' basefile_date]);
    storeData.infosetdates(idate) = datesToMerge(idate);
    
    for idgp = 1:length(dgpmodels)
        
        dgpuse = dgpmodels{idgp};
        
        for ifit = 1:length(fitmodels)
            
            fituse = fitmodels{ifit};

            storeData.simstruct.(dgpuse).(fituse).frcst(:,:,:,idate,:) = loadData.simstruct.(dgpuse).(fituse).frcst(:,:,:,1,:);
            storeData.simstruct.(dgpuse).(fituse).cumfrcst(:,:,:,idate,:) = loadData.simstruct.(dgpuse).(fituse).cumfrcst(:,:,:,1,:);            
            storeData.simstruct.(dgpuse).(fituse).oilimpz(:,:,:,idate,:) = loadData.simstruct.(dgpuse).(fituse).oilimpz(:,:,:,1,:);
            storeData.simstruct.(dgpuse).(fituse).cumoilimpz(:,:,:,idate,:) = loadData.simstruct.(dgpuse).(fituse).cumoilimpz(:,:,:,1,:);
            
        end
        
    end
    
    for ifit = 1:length(fitmodels)
        
        fituse = fitmodels{ifit};
        
        storeData.empstruct.(fituse).oilimpz(:,:,:,idate) = loadData.empstruct.(fituse).oilimpz(:,:,:,1);
        storeData.empstruct.(fituse).cumoilimpz(:,:,:,idate) = loadData.empstruct.(fituse).cumoilimpz(:,:,:,1);   
            
    end
end

storeData.waldstat_dlin = NaN(nstep,nshocks,nstartpoints);
storeData.waldstat_asym = NaN(nstep,2,nstartpoints);
storeData.wald_cross = NaN(nstep,2,nstartpoints,nstartpoints);

for ihist = 1:nstartpoints
    for ishock = 1:nshocks
        
        simdiff_ni3_lin = squeeze(storeData.simstruct.oil_gdp_ni3.oil_gdp_ni3.cumoilimpz(:,2,ishock,ihist,:)-storeData.simstruct.oil_gdp_ni3.oil_gdp.cumoilimpz(:,2,ishock,ihist,:));
        vcovmat = cov(simdiff_ni3_lin');
    
        for istep = 1:nstep
            lin_cumoilimpz = storeData.empstruct.oil_gdp.cumoilimpz(1:istep,2,ishock,ihist);
            ni3_cumoilimpz = storeData.empstruct.oil_gdp_ni3.cumoilimpz(1:istep,2,ishock,ihist);
            diff_cumoilimpz = ni3_cumoilimpz - lin_cumoilimpz;
            storeData.waldstat_dlin(istep,ishock,ihist) = diff_cumoilimpz'*inv(vcovmat(1:istep,1:istep))*diff_cumoilimpz;   
        end
    end
end

for ihist = 1:nstartpoints
    
    simdiff_1std = squeeze(storeData.simstruct.oil_gdp_ni3.oil_gdp_ni3.cumoilimpz(:,2,2,ihist,:)+storeData.simstruct.oil_gdp_ni3.oil_gdp_ni3.cumoilimpz(:,2,3,ihist,:));
    simdiff_2std = squeeze(storeData.simstruct.oil_gdp_ni3.oil_gdp_ni3.cumoilimpz(:,2,1,ihist,:)+storeData.simstruct.oil_gdp_ni3.oil_gdp_ni3.cumoilimpz(:,2,4,ihist,:));    
    vcovmat_1std = cov(simdiff_1std');
    vcovmat_2std = cov(simdiff_2std');
    empdiff_1std = storeData.empstruct.oil_gdp_ni3.cumoilimpz(:,2,2,ihist)+storeData.empstruct.oil_gdp_ni3.cumoilimpz(:,2,3,ihist);
    empdiff_2std = storeData.empstruct.oil_gdp_ni3.cumoilimpz(:,2,1,ihist)+storeData.empstruct.oil_gdp_ni3.cumoilimpz(:,2,4,ihist);            
    
    for istep = 1:nstep
        storeData.waldstat_asym(istep,1,ihist) = empdiff_1std(1:istep,:)'*inv(vcovmat_1std(1:istep,1:istep))*empdiff_1std(1:istep,:);
        storeData.waldstat_asym(istep,2,ihist) = empdiff_2std(1:istep,:)'*inv(vcovmat_2std(1:istep,1:istep))*empdiff_2std(1:istep,:);
    end
    
end

for zx = 1:nstartpoints-1
    for zy = (zx+1):nstartpoints

        simdiff_cross_1std = squeeze(storeData.simstruct.oil_gdp_ni3.oil_gdp_ni3.cumoilimpz(:,2,3,zx,:)) - squeeze(storeData.simstruct.oil_gdp_ni3.oil_gdp_ni3.cumoilimpz(:,2,3,zy,:));
        simdiff_cross_2std = squeeze(storeData.simstruct.oil_gdp_ni3.oil_gdp_ni3.cumoilimpz(:,2,4,zx,:)) - squeeze(storeData.simstruct.oil_gdp_ni3.oil_gdp_ni3.cumoilimpz(:,2,4,zy,:));
        var_cross_1std = cov(simdiff_cross_1std');
        var_cross_2std = cov(simdiff_cross_2std');
        empdiff_cross_1std = storeData.empstruct.oil_gdp_ni3.cumoilimpz(:,2,3,zx) - storeData.empstruct.oil_gdp_ni3.cumoilimpz(:,2,3,zy);
        empdiff_cross_2std = storeData.empstruct.oil_gdp_ni3.cumoilimpz(:,2,4,zx) - storeData.empstruct.oil_gdp_ni3.cumoilimpz(:,2,4,zy);

        for istep = 1:nstep
            storeData.wald_cross(istep,1,zx,zy) = empdiff_cross_1std(1:istep,:)'*inv(var_cross_1std(1:istep,1:istep))*empdiff_cross_1std(1:istep,:);
            storeData.wald_cross(istep,2,zx,zy) = empdiff_cross_2std(1:istep,:)'*inv(var_cross_2std(1:istep,1:istep))*empdiff_cross_2std(1:istep,:);
        end
    
    end
end

save([basefile '_mergedates_' basefile_date],'-struct','storeData','-v7.3');
            
        
        
        
        
        
        
        
        
        
        
        